# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
$LOAD_PATH.unshift(File.absolute_path("#{__dir__}/../"))

require 'puppet_x/enterprisemodules/mssql/fact'
require 'puppet/feature/mssql_running'
include MssqlFeature
include Puppet_X::EnterpriseModules::MsSql::Fact
require 'entitlement/entitlement'
      ::Entitlement::Entitlement.entitled?("mssql_secured#facts#mssql_service_accounts")
Facter.add('mssql_service_accounts') do
  confine do
    Puppet.features.mssql_running?
  end
  mssql_array_fact({:servicename => 'servicename', :service_account=>'service_account'}) { 'SELECT servicename, service_account FROM sys.dm_server_services' }
end