#
# See the file "LICENSE" for the full license governing this code.
#
module MssqlFeature
  def self.mssql_running_check
    Puppet.debug 'Feature mssql_running checking availability'
    if Facter.value(:kernel) == 'windows'
      proc = `tasklist | findstr sqlwriter.exe`
    else
      false
    end
    if proc != ''
      Puppet.debug 'Feature mssql_running available'
      true
    else
      Puppet.debug 'Feature mssql_running **NOT** available'
      false
    end
  end

  Puppet.features.add(:mssql_running) do
    mssql_running_check
  end

  Puppet.features.send :meta_def, 'mssql_running?' do
    name = :mssql_running
    final = @results[name]
    @results[name] = MssqlFeature.mssql_running_check unless final
    @results[name]
  end
end
