require 'puppet_x/enterprisemodules/mssql/powershell'
require 'easy_type'

module Puppet_X
  module EnterpriseModules
    module MsSql
      class Access
        include ::EasyType::Template

        def initialize(database, instance = 'MSSQLSERVER', node = Facter.value('hostname') )
          @node     = node
          @instance = instance
          @database = database
        end

        def execute(command)
          self.execute(command, @database, @instance, @node)
        end

        def self.execute_file(file_name, database, instance='MSSQLSERVER', node=Facter.value('hostname'))
          content = template('mssql_secured/sql/sql_file.ps1.erb', binding)
          Puppet_X::EnterpriseModules::MsSql::Powershell.execute(content)
        end

        def self.execute(command, database, instance='MSSQLSERVER', node=Facter.value('hostname'))
          content = template('mssql_secured/sql/sql_statement.ps1.erb', binding)
          Puppet_X::EnterpriseModules::MsSql::Powershell.execute(content)
        end

      end
    end
  end
end