begin
  require 'ruby-pwsh' if Puppet::Util::Platform.windows?
rescue LoadError
  raise 'Could not load the "ruby-pwsh" library; is the dependency module puppetlabs-pwshlib installed in this environment?'
end

module Puppet_X
  module EnterpriseModules
    module MsSql
      class Powershell

        def initialize
          @shell = self.get_shell
        end

        def execute(command)
          @shell.execute(command)
        end

        def self.execute(command)
          @shell ||= get_shell
          @shell.execute(command)
        end

        private

        #
        # Get a Powershell daemon handler
        #
        def self.get_shell
          @posh = Pwsh::Manager.instance(Pwsh::Manager.powershell_path, Pwsh::Manager.powershell_args)
        end
      end
    end
  end
end


