# require 'puppet_x/enterprisemodules/powershell'
require 'easy_type'
require 'puppet_x/enterprisemodules/mssql/access'
module Puppet_X
  module EnterpriseModules
    module MsSql
      module Sql
        include EasyType::Helpers

        def self.included( parent)
          parent.extend(self)
        end

        def all_instances
          Facter.value(:mssql_instances).keys
        end

        def sql_on_all_databases(query)
          fail 'todo'
        end

        def sql_on_all_master_databases(query)
          results = []
          all_instances.each do |instance|
            results += sql(query, { :database => 'master', :instance => instance })
          end
          results
        end

        def sql_file(file, options)
          csv_string = Access.execute_file(file, options[:database], options[:instance])[:stdout]
          if options.fetch(:parse) { true }
            csv_string.empty? ? [] : convert_csv_data_to_hash(csv_string).collect{|e| e.merge({'database' => options[:database], 'instance' => options[:instance]})}
          end
        end


        def sql(statement, options)
          csv_string = Access.execute(statement, options[:database], options[:instance])[:stdout]
          if options.fetch(:parse) { true }
            (csv_string.nil? || csv_string.empty?) ? [] : convert_csv_data_to_hash(csv_string).collect{|e| e.merge({'database' => options[:database], 'instance' => options[:instance]})}
          end
        end
      end
    end
  end
end